SystemOrganization addCategory: #OLE!

SketchMorph subclass: #RippedOffMorph
	instanceVariableNames: 'target patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:21'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	morph == patch ifTrue: [self replacePatch: morph].! !

!RippedOffMorph methodsFor: '*ole' stamp: 'lg 9/25/2007 12:07'!
replacePatch: patchMorph
	target extent: patchMorph extent; position: patchMorph position.
	patch owner replaceSubmorph: patchMorph by: target.
	OLE congratulate.! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:22'!
setPatch: morph 
	patch := morph.
! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:26'!
setTarget: morph 
	target := morph.
	self form: target imageForm.! !

Morph subclass: #MatchStick
	instanceVariableNames: 'head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MatchStick class methodsFor: 'as yet unclassified' stamp: 'Ram 11/22/2007 12:46'!
newWithHead: aNumber
	| model |
	model := self basicNew.
	model
		head: aNumber.
	model initialize.
	^model.
	! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/20/2007 14:25'!
click: anEvent
	^self.! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/20/2007 16:07'!
doubleClick: anEvent
	self heading: self heading + 45 .
	^self.! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/22/2007 14:30'!
drawOn: aConvas
	|aBounds stickHeight stickWidth|
	(self head = 0) ifTrue:[
	stickHeight:=(self height/3) asFloat.
	stickWidth:=(self width/3)asFloat.
	aBounds:= self bounds top: self 	top + stickHeight.
	aBounds:= aBounds bottom: self bottom - stickWidth .
	aConvas fillRectangle: aBounds color: Color red.].

	(self head = 90) ifTrue:[
	stickHeight:=(self height/3) asFloat.
	stickWidth:=(self width/3)asFloat.
	aBounds:= self bounds left: self 	left + stickWidth+ 12.5.
	aBounds:= aBounds right: self right - stickWidth .
	aConvas fillRectangle: aBounds color: Color red.
	]! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/20/2007 14:21'!
firstClickTimedOut: anEvent
	anEvent hand grabMorph: self.! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/20/2007 14:01'!
handlesMouseDown: anEvent
	^true.! !

!MatchStick methodsFor: 'accessing' stamp: 'Ram 11/22/2007 12:40'!
head
	"Answer the value of head"

	^ head! !

!MatchStick methodsFor: 'accessing' stamp: 'Ram 11/22/2007 12:40'!
head: anObject
	"Set the value of head"

	head _ anObject! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/20/2007 13:36'!
initialize
	super initialize.
! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/23/2007 10:56'!
mouseDown: anEvent
		anEvent hand 
		waitForClicksOrDrag: self 
		event: anEvent
		selectors:{#click: . #doubleClick:. #firstClickTimedOut:. #mouseUp:. nil} 
		threshold: 5.
		Transcript show: 'mouse down event: '		.
		Transcript show: self owner.

		
	! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/23/2007 10:57'!
mouseUp: anEvent

	Transcript show: 'mouse up event: '		.
	Transcript show: self owner.
	^true! !

!MatchStick methodsFor: 'as yet unclassified' stamp: 'Ram 11/20/2007 13:56'!
testEvent: aString
	Transcript show: aString.! !

!Morph methodsFor: '*ole-menus' stamp: 'lg 9/25/2007 11:31'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' translated action: #goBehind.
		aMenu add: 'bring to front' translated action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu add: 'rip off' translated action: #ripoff.
		aMenu addLine].

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph.
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	Preferences eToyFriendly ifFalse: [self addHaloActionsTo: aMenu].
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	Preferences eToyFriendly ifFalse: [self addCopyItemsTo: aMenu].
	self addPlayerItemsTo: aMenu.
	Preferences eToyFriendly ifFalse: [self addExportMenuItems: aMenu hand: aHandMorph].
	Preferences eToyFriendly ifFalse: [self addStackItemsTo: aMenu].
	self addMiscExtrasTo: aMenu.
	Preferences eToyFriendly ifFalse: [Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph]].

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables _ self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: {unlockables first externalName})
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 10:20'!
exchangeWith: morph 
	morph position: self position; extent: self extent.
	owner replaceSubmorph: self by: morph.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/1/2007 15:19'!
isGameInput
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 9/24/2007 17:00'!
ripOff
	| m |
	m := RipoffPatchMorph new initialize setTarget: self.
	owner addMorph: m after: self.
	owner removeMorph: self.
	self position: World activeHand position.
	World activeHand grabMorph: self.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/29/2007 13:03'!
ripoff
   | morph patch |
	morph := RippedOffMorph new setTarget: self.
	patch := RipoffPatchMorph new setTarget: morph.
	morph setPatch: patch.
	self exchangeWith: patch.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.
! !

Morph subclass: #Question
	instanceVariableNames: 'question answer image optionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
answer
	"Answer the value of answer"

	^ answer! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
image
	"Answer the value of image"

	^ image! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
image: anObject
	"Set the value of image"

	image _ anObject! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
optionList
	"Answer the value of optionList"

	^ optionList! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
optionList: anObject
	"Set the value of optionList"

	optionList _ anObject! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
question
	"Answer the value of question"

	^ question! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
question: anObject
	"Set the value of question"

	question _ anObject! !

Morph subclass: #RipoffPatch
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatch methodsFor: '*ole' stamp: 'lg 9/24/2007 17:54'!
setTarget: morph
	target := morph.
	self position: morph position; extent: morph extent.! !

Morph subclass: #RipoffPatchMorph
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/29/2007 13:03'!
initialize
	super initialize.
	self fillStyle: Color orange.
	self beSticky.
	self layoutPolicy: TableLayout new.
	self cellPositioning: #center; wrapCentering: #center; listCentering: #center.
	"XXX Add a text morph of a question mark"
	self cornerStyle: #rounded.
	! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:19'!
setTarget: ripoffMorph 
	target := ripoffMorph.! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:20'!
wantsDroppedMorph: morph event: evt
	^morph == target.

! !

TextMorph subclass: #GameTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^self getNumericValue.! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
increment
	self setNumericValue: self getNumericValue + 1.! !

!GameTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:25'!
isGameInput
	^true! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
setGameValue: n 
	self setNumericValue: n.! !

RectangleMorph subclass: #NumberGame
	instanceVariableNames: 'minValue maxSum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NumberGame class methodsFor: 'game' stamp: 'lg 10/1/2007 16:29'!
answer: n 
	World allMorphsDo: [ :m | (m isKindOf: self) ifTrue: [m answer: n]].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:32'!
answer: n
	n = self getGameValue ifTrue: [self beep: 'clink'. self newGame]
								 ifFalse: [self beep: 'horn'].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:30'!
gameInputs
	^World allMorphs select: #isGameInput.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^(self gameInputs collect: #getGameValue) sum.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:17'!
increaseInputs
	| seed |
	seed := (0 to: maxSum - (minValue * self gameInputs size)) atRandom.
	seed timesRepeat: [ self gameInputs atRandom increment ].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'jwl 10/1/2007 17:37'!
initialize
	super initialize.
	minValue := 1.
	maxSum := 9.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 16:14'!
newGame
	self resetInputs; increaseInputs.
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:15'!
resetInputs
	self gameInputs do: [ :input | input setGameValue: minValue ].
! !

!Player methodsFor: '*ole' stamp: 'Ram 11/8/2007 11:37'!
test
	costume test! !

!Symbol methodsFor: '*ole' stamp: 'jwl 10/1/2007 17:40'!
value: x 
	^ x perform: self.
! !

Object subclass: #ActionVerb
	instanceVariableNames: 'verbList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ActionVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 12:31'!
newWithVerbs: anOrderedCollection
	| model |
	model:= self basicNew.
	model verbList: anOrderedCollection.
	model initialize.
	^model.
! !

!ActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 13:01'!
initialize
	super initialize.
! !

!ActionVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:15'!
verbList
	"Answer the value of verbList"

	^ verbList! !

!ActionVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:15'!
verbList: anObject
	"Set the value of verbList"

	verbList _ anObject! !

Object subclass: #AcVerb
	instanceVariableNames: 'verb question image answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AcVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/20/2007 11:50'!
newVerbWith: aVerb question: aQuestion image: anImage answer: anAnswer
	| model |
	model:= self basicNew.
	model 
		verb: aVerb;
		question: aQuestion;
		image: anImage;
		answer: anAnswer.
	model initialize.
	^model.

		

	! !

!AcVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 12:44'!
newVerbWith: aVerb question: aQuestion image: anImage
	| model |
	model:= self basicNew.
	model 
		verb: aVerb;
		question: aQuestion;
		image: anImage.
	model initialize.
	^model.

		

	! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/20/2007 11:46'!
answer
	"Answer the value of answer"

	^ answer! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/20/2007 11:46'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
image
	"Answer the value of image"

	^ image! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
image: anObject
	"Set the value of image"

	image _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
question
	"Answer the value of question"

	^ question! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
question: anObject
	"Set the value of question"

	question _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
verb
	"Answer the value of verb"

	^ verb! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
verb: anObject
	"Set the value of verb"

	verb _ anObject! !

Object subclass: #ColorPattern
	instanceVariableNames: 'blueCount yellowCount orangeCount greenCount colorList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
blueCount
	"Answer the value of blueCount"

	^ blueCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
blueCount: anObject
	"Set the value of blueCount"

	blueCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/21/2007 10:21'!
clearPattern: object

	
| myPlayer |
	object allMorphsDo:[:sub | 
		(sub isKindOf: ImageMorph)ifTrue:[
		myPlayer := sub player.

		]
	]! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
colorList
	"Answer the value of colorList"

	^ colorList! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
colorList: anObject
	"Set the value of colorList"

	colorList _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
greenCount
	"Answer the value of greenCount"

	^ greenCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
greenCount: anObject
	"Set the value of greenCount"

	greenCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:11'!
initialize
	super initialize.
	self orangeCount:0.
	self blueCount:0.
	self yellowCount:0.
	self greenCount: 0.
	self colorList: OrderedCollection new.
! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:03'!
iteratePattern: object
	
| myPlayer myColor |
	object allMorphsDo:[:sub | 
		(sub isKindOf: ImageMorph)ifTrue:[
		myPlayer := sub player.
		myColor := myPlayer getColor1.
		(myColor = (Color r: 1.0 g: 1.0 b: 0.194)) ifTrue:[
			colorList add: 'Yellow'.
			yellowCount:= yellowCount +1.
			].
		(myColor = (Color r: 0.387 g: 0.613 b: 0.0)) ifTrue:[
			colorList add: 'Green'.
			greenCount:=greenCount +1.
			].
		(myColor = (Color r: 1.0 g: 0.484 b: 0.0)) ifTrue:[
			colorList add: 'Orange'.
			orangeCount:= orangeCount + 1.
			].
		(myColor = (Color r: 0.0 g: 0.194 b: 1.0)) ifTrue:[
			colorList add: 'Blue'.
			blueCount:= blueCount + 1.
			].
		]
	]! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
orangeCount
	"Answer the value of orangeCount"

	^ orangeCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
orangeCount: anObject
	"Set the value of orangeCount"

	orangeCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
yellowCount
	"Answer the value of yellowCount"

	^ yellowCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
yellowCount: anObject
	"Set the value of yellowCount"

	yellowCount _ anObject! !

Object subclass: #OLE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!OLE class methodsFor: 'sound effects' stamp: 'lg 9/29/2007 13:02'!
congratulate
	"Not implemented" nil.! !

Object subclass: #Toothpick
	instanceVariableNames: 'toothpickImage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!Toothpick methodsFor: 'as yet unclassified' stamp: 'Ram 11/19/2007 18:14'!
createToothpick
	| aForm |
	super initialize.
	aForm:= ImageReadWriter formFromFileNamed: 'tooth_pick.png'.
	toothpickImage:=ImageMorph new newForm: aForm
	toothpickImage openInWorld.! !

!Toothpick methodsFor: 'as yet unclassified' stamp: 'Ram 11/19/2007 18:14'!
handleMouseEvent: anEvent
	^true! !

!Toothpick methodsFor: 'as yet unclassified' stamp: 'Ram 11/19/2007 18:18'!
handleMouseUp: anEvent
	self rotateBy:45.! !

!LedMorph methodsFor: '*ole' stamp: 'Ram 11/8/2007 11:46'!
test
	self inform: 'this is a test'! !

AlignmentMorph subclass: #DigitChooserMorph
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!DigitChooserMorph class methodsFor: 'as yet unclassified' stamp: 'lg 9/21/2007 14:07'!
additionsToViewerCategories
	^ #( (basic ((slot numericValue 'The most recently pressed digit (or zero, initially).' Number readWrite Player getNumericValue Player setNumericValue:))))! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:37'!
addButtonRows
	| row |
	#( (1 2 3) (4 5 6) (7 8 9) ) do:
		[ :digits |
			row := AlignmentMorph newRow vResizing: #spaceFill; cellInset: 3; yourself.
			digits do: [ :d | row addMorphBack: (self buttonFor: d)].
			self addMorph: row]! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 10/1/2007 16:45'!
buttonFor: digit 
	^ SimpleButtonMorph new target: NumberGame;
		label: digit asString font: Preferences standardEToysButtonFont;
		actionSelector: #answer:;
		arguments: { digit };
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:46'!
initialize
	super initialize.
	self extent: 300@300.
	self layoutPolicy: TableLayout new.
	self listDirection: #bottomToTop.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth := 2.
	self addButtonRows.
! !
